sc::ShmMemoryGrp(3)

NAME
sc::ShmMemoryGrp -

The ShmMemoryGrp concrete class provides an implementation of

 MsgMemoryGrp.

SYNOPSIS

#include <memshm.h>

Inherits sc::MsgMemoryGrp.

  Public Member Functions
ShmMemoryGrp (const Ref< MessageGrp > &msg)
ShmMemoryGrp (const Ref< KeyVal > &)
void set_localsize (size_t)
Set the size of locally held memory.
void * localdata ()
Returns a pointer to the local data.
void * obtain_readwrite (distsize_t offset, int size)
Only one thread can have an unreleased obtain_readwrite at a time.
void * obtain_readonly (distsize_t offset, int size)
This gives read access to the memory location. No locking is done.
void * obtain_writeonly (distsize_t offset, int size)
This gives write access to the memory location. No locking is done.
void release_readonly (void *data, distsize_t offset, int size)
This is called when read access is no longer needed.
void release_writeonly (void *data, distsize_t offset, int size)
This is called when write access is no longer needed.
void release_readwrite (void *data, distsize_t offset, int size)
This is called when read/write access is no longer needed.
void print (std::ostream &o=ExEnv::out0()) const
Prints out information about the object.

  Additional Inherited Members

Detailed Description

The ShmMemoryGrp concrete class provides an implementation of

 MsgMemoryGrp. It uses SYSV IPC to provided shared memory in a system that provide shared memory in hardware. It is very fast and reliable.

Member Function Documentation

  void* sc::ShmMemoryGrp::obtain_readwrite (distsize_toffset, intsize) [virtual]

Only one thread can have an unreleased obtain_readwrite at a time. The actual memory region locked can be larger than that requested. If the memory region is already locked this will block. For this reason, data should be held as read/write for as short a time as possible.

Implements sc::MemoryGrp.

  void sc::ShmMemoryGrp::release_readwrite (void *data, distsize_toffset, intsize) [virtual]

This is called when read/write access is no longer needed. The memory will be unlocked.

Implements sc::MemoryGrp.

  void sc::ShmMemoryGrp::set_localsize (size_t) [virtual]

Set the size of locally held memory. When memory is accessed using a global offset counting starts at node 0 and proceeds up to node n() - 1.

Reimplemented from sc::MsgMemoryGrp.

Author

Generated automatically by Doxygen for MPQC from the source code.